'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AdharaFormView = function (_AdharaView) {
    _inherits(AdharaFormView, _AdharaView);

    function AdharaFormView() {
        _classCallCheck(this, AdharaFormView);

        return _possibleConstructorReturn(this, (AdharaFormView.__proto__ || Object.getPrototypeOf(AdharaFormView)).apply(this, arguments));
    }

    _createClass(AdharaFormView, [{
        key: 'onSuccess',


        /**
         * @function
         * @instance
         * @param {Object} data - Response Object
         * @description This method will be called on forms's POST/PUT call success
         * */
        value: function onSuccess(data) {}
        //Override this to handle success event...


        /**
         * @function
         * @instance
         * @param {Object} error - Error Response Object
         * @description This method will be called on forms's POST/PUT failure
         * */

    }, {
        key: 'onError',
        value: function onError(error) {
            Toast.error(error);
        }

        /**
         * @function
         * @instance
         * @param {Object} data - Form data
         * @returns {Boolean} Whether the data is valid or not
         * */

    }, {
        key: 'validate',
        value: function validate(data) {
            var validate_fn = this.formElement.getAttribute('validate-data');
            if (validate_fn) {
                return !!call_fn(validate_fn, data);
            }
            return true;
        }

        /**
         * @function
         * @instance
         * @param {Object} data - Form data
         * @returns {Object} Modified/Formatted data
         * */

    }, {
        key: 'formatData',
        value: function formatData(data) {
            var format_fn = this.formElement.getAttribute('format-data');
            if (format_fn) {
                data = call_fn(format_fn, data);
            }
            return data;
        }

        /**
         * @getter
         * @instance
         * @returns {HTMLFormElement} HTML node which represents the Form element
         * */

    }, {
        key: '_handleForm',


        /**
         * @getter
         * @private
         * @description handle making API call on behalf of the form
         * */
        value: function _handleForm() {
            var _this2 = this;

            var form = this.formElement;
            if (form.submitting) {
                return;
            }
            form.submitting = true;
            var apiData = void 0;
            if (!!form.querySelector('input[type="file"]')) {
                // ~ if(hasFiles){
                apiData = new FormData(form);
            } else {
                var formData = jQuery(form).serializeArray();
                apiData = {};
                jQuery.each(formData, function (i, fieldData) {
                    apiData[fieldData.name] = fieldData.value;
                });
            }
            if (!this.validate(apiData)) {
                return;
            }
            apiData = this.formatData(apiData);
            return Controller.control(this.method, {
                data_config: {
                    url: this.action
                },
                form: form,
                processor: {
                    success: function success(query_type, entity_config, response, response_code, pass_over) {
                        if (_this2.clearFormOnSubmit) {
                            form.reset();
                        }
                        _this2.onSuccess(response);
                        form.submitting = false;
                    },
                    error: function error(query_type, entity_config, _error, response_code, pass_over) {
                        _this2.onError(_error);
                        form.submitting = false;
                    }
                }
            }, apiData);
        }
    }, {
        key: '_format',
        value: function _format(container) {
            var _this3 = this;

            this.formElement.addEventListener("submit", function (event) {
                event.preventDefault();
                _this3.submit();
            });
            _get(AdharaFormView.prototype.__proto__ || Object.getPrototypeOf(AdharaFormView.prototype), '_format', this).call(this, container);
        }
    }, {
        key: 'submit',
        value: function submit() {
            this._handleForm(this.formElement);
        }
    }, {
        key: 'action',


        /**
         * @getter
         * @returns {String|null} action, URL to be called to post data to.
         * */
        get: function get() {
            return this.formElement.action.split(window.location.host)[1];
        }
    }, {
        key: 'method',
        get: function get() {
            return this.formElement.getAttribute('api-method') || "post";
        }

        /**
         * @getter
         * @instance
         * @returns {Boolean} whether to clear form on successful submission or not
         * */

    }, {
        key: 'clearFormOnSubmit',
        get: function get() {
            return this.formElement.getAttribute('form-clear') === "true";
        }
    }, {
        key: 'formElement',
        get: function get() {
            if (!this._formElement || !document.body.contains(this._formElement)) {
                this._formElement = this.getParentContainerElement().querySelector("form");
            }
            return this._formElement;
        }
    }]);

    return AdharaFormView;
}(AdharaView);
//# sourceMappingURL=FormView.js.map